<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Eulers (Rotations)</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-utilities.html" title="Utilities">
<link rel="prev" href="cogl-2.0-experimental-3-Component-Vectors.html" title="3 Component Vectors">
<link rel="next" href="cogl-2.0-experimental-Quaternions-(Rotations).html" title="Quaternions (Rotations)">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-2.0-experimental-3-Component-Vectors.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-utilities.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="cogl-2.0-experimental-Quaternions-(Rotations).html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-Eulers-(Rotations).synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-Eulers-(Rotations).description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-Eulers-(Rotations)"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-Eulers-(Rotations).top_of_page"></a>Eulers (Rotations)</span></h2>
<p>Eulers (Rotations) — Functions for initializing and manipulating
euler angles.</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-Eulers-(Rotations).synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis">                    <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler">CoglEuler</a>;
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#cogl-euler-init" title="cogl_euler_init ()">cogl_euler_init</a>                     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> heading</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> pitch</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> roll</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#cogl-euler-init-from-matrix" title="cogl_euler_init_from_matrix ()">cogl_euler_init_from_matrix</a>         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#cogl-euler-init-from-quaternion" title="cogl_euler_init_from_quaternion ()">cogl_euler_init_from_quaternion</a>     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#cogl-euler-equal" title="cogl_euler_equal ()">cogl_euler_equal</a>                    (<em class="parameter"><code>const <span class="type">void</span> *v1</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *v2</code></em>);
<a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="returnvalue">CoglEuler</span></a> *         <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#cogl-euler-copy" title="cogl_euler_copy ()">cogl_euler_copy</a>                     (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *src</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#cogl-euler-free" title="cogl_euler_free ()">cogl_euler_free</a>                     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-Eulers-(Rotations).description"></a><h2>Description</h2>
<p>
Euler angles are a simple representation of a 3 dimensional
rotation; comprised of 3 ordered heading, pitch and roll rotations.
An important thing to understand is that the axis of rotation
belong to the object being rotated and so they also rotate as each
of the heading, pitch and roll rotations are applied.
</p>
<p>
One way to consider euler angles is to imagine controlling an
aeroplane, where you first choose a heading (Such as flying south
east), then you set the pitch (such as 30 degrees to take off) and
then you might set a roll, by dipping the left, wing as you prepare
to turn.
</p>
<p>
They have some advantages and limitations that it helps to be
aware of:
</p>
<p>
Advantages:
</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem">
Easy to understand and use, compared to quaternions and matrices,
so may be a good choice for a user interface.
</li>
<li class="listitem">
Efficient storage, needing only 3 components any rotation can be
represented.
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Actually the <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> type isn't optimized for size because
we may cache the equivalent <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> along with a euler
rotation, but it would be trivial for an application to track the
components of euler rotations in a packed float array if optimizing
for size was important. The values could be passed to Cogl only when
manipulation is necessary.</div>
</li>
</ul></div>
<p>
</p>
<p>
Disadvantages:
</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem">
Aliasing: it's possible to represent some rotations with multiple
different heading, pitch and roll rotations.
</li>
<li class="listitem">
They can suffer from a problem called Gimbal Lock. A good
explanation of this can be seen on wikipedia here:
http://en.wikipedia.org/wiki/Gimbal_lock but basically two
of the axis of rotation may become aligned and so you loose a
degree of freedom. For example a pitch of +-90° would mean that
heading and bank rotate around the same axis.
</li>
<li class="listitem">
If you use euler angles to orient something in 3D space and try to
transition between orientations by interpolating the component
angles you probably wont get the transitions you expect as they may
not follow the shortest path between the two orientations.
</li>
<li class="listitem">
There's no standard to what order the component axis rotations are
applied. The most common convention seems to be what we do in Cogl
with heading (y-axis), pitch (x-axis) and then roll (z-axis), but
other software might apply x-axis, y-axis then z-axis or any other
order so you need to consider this if you are accepting euler
rotations from some other software. Other software may also use
slightly different aeronautical terms, such as "yaw" instead of
"heading" or "bank" instead of "roll".
</li>
</ul></div>
<p>
</p>
<p>
To minimize the aliasing issue we may refer to "Canonical Euler"
angles where heading and roll are restricted to +- 180° and pitch is
restricted to +- 90°. If pitch is +- 90° bank is set to 0°.
</p>
<p>
Quaternions don't suffer from Gimbal Lock and they can be nicely
interpolated between, their disadvantage is that they don't have an
intuitive representation.
</p>
<p>
A common practice is to accept angles in the intuitive Euler form
and convert them to quaternions internally to avoid Gimbal Lock and
handle interpolations. See <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-init-from-euler" title="cogl_quaternion_init_from_euler ()"><code class="function">cogl_quaternion_init_from_euler()</code></a>.
</p>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-Eulers-(Rotations).details"></a><h2>Details</h2>
<div class="refsect2">
<a name="CoglEuler"></a><h3>CoglEuler</h3>
<pre class="programlisting">typedef struct {
  float heading;
  float pitch;
  float roll;
} CoglEuler;
</pre>
<p>
Represents an ordered rotation first of <em class="parameter"><code>heading</code></em> degrees around an
object's y axis, then <em class="parameter"><code>pitch</code></em> degrees around an object's x axis and
finally <em class="parameter"><code>roll</code></em> degrees around an object's z axis.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>It's important to understand the that axis are associated
with the object being rotated, so the axis also rotate in sequence
with the rotations being applied.</div>
<p>
</p>
<p>
The members of a <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> can be initialized, for example, with
<a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#cogl-euler-init" title="cogl_euler_init ()"><code class="function">cogl_euler_init()</code></a> and <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#cogl-euler-init-from-quaternion" title="cogl_euler_init_from_quaternion ()"><code class="function">cogl_euler_init_from_quaternion()</code></a>.
</p>
<p>
You may also want to look at <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-init-from-euler" title="cogl_quaternion_init_from_euler ()"><code class="function">cogl_quaternion_init_from_euler()</code></a> if
you want to do interpolation between 3d rotations.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><span class="type">float</span> <em class="structfield"><code><a name="CoglEuler.heading"></a>heading</code></em>;</span></p></td>
<td>Angle to rotate around an object's y axis</td>
</tr>
<tr>
<td><p><span class="term"><span class="type">float</span> <em class="structfield"><code><a name="CoglEuler.pitch"></a>pitch</code></em>;</span></p></td>
<td>Angle to rotate around an object's x axis</td>
</tr>
<tr>
<td><p><span class="term"><span class="type">float</span> <em class="structfield"><code><a name="CoglEuler.roll"></a>roll</code></em>;</span></p></td>
<td>Angle to rotate around an object's z axis</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-euler-init"></a><h3>cogl_euler_init ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_euler_init                     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> heading</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> pitch</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> roll</code></em>);</pre>
<p>
Initializes <em class="parameter"><code>euler</code></em> to represent a rotation of <em class="parameter"><code>x_angle</code></em> degrees
around the x axis, then <em class="parameter"><code>y_angle</code></em> degrees around the y_axis and
<em class="parameter"><code>z_angle</code></em> degrees around the z axis.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>euler</code></em> :</span></p></td>
<td>The <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> angle to initialize</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>heading</code></em> :</span></p></td>
<td>Angle to rotate around an object's y axis</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>pitch</code></em> :</span></p></td>
<td>Angle to rotate around an object's x axis</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>roll</code></em> :</span></p></td>
<td>Angle to rotate around an object's z axis</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-euler-init-from-matrix"></a><h3>cogl_euler_init_from_matrix ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_euler_init_from_matrix         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> *matrix</code></em>);</pre>
<p>
Extracts a euler rotation from the given <em class="parameter"><code>matrix</code></em> and
initializses <em class="parameter"><code>euler</code></em> with the component x, y and z rotation angles.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>euler</code></em> :</span></p></td>
<td>The <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> angle to initialize</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>matrix</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Matrices.html#CoglMatrix" title="CoglMatrix"><span class="type">CoglMatrix</span></a> containing a rotation, but no scaling,
mirroring or skewing.</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-euler-init-from-quaternion"></a><h3>cogl_euler_init_from_quaternion ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_euler_init_from_quaternion     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);</pre>
<p>
Initializes a <em class="parameter"><code>euler</code></em> rotation with the equivalent rotation
represented by the given <em class="parameter"><code>quaternion</code></em>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>euler</code></em> :</span></p></td>
<td>The <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> angle to initialize</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> with the rotation to initialize with</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-euler-equal"></a><h3>cogl_euler_equal ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_euler_equal                    (<em class="parameter"><code>const <span class="type">void</span> *v1</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *v2</code></em>);</pre>
<p>
Compares the two given euler angles <em class="parameter"><code>v1</code></em> and <em class="parameter"><code>v1</code></em> and it they are
equal returns <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> else <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a>.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>This function only checks that all three components rotations
are numerically equal, it does not consider that some rotations
can be represented with different component rotations</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>v1</code></em> :</span></p></td>
<td>The first euler angle to compare</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>v2</code></em> :</span></p></td>
<td>The second euler angle to compare</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if <em class="parameter"><code>v1</code></em> and <em class="parameter"><code>v2</code></em> are equal else <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a>.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-euler-copy"></a><h3>cogl_euler_copy ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="returnvalue">CoglEuler</span></a> *         cogl_euler_copy                     (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *src</code></em>);</pre>
<p>
Allocates a new <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> and initilizes it with the component
angles of <em class="parameter"><code>src</code></em>. The newly allocated euler should be freed using
<a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#cogl-euler-free" title="cogl_euler_free ()"><code class="function">cogl_euler_free()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>src</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> to copy</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A newly allocated <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-euler-free"></a><h3>cogl_euler_free ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_euler_free                     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>);</pre>
<p>
Frees a <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> that was previously allocated using
<a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#cogl-euler-copy" title="cogl_euler_copy ()"><code class="function">cogl_euler_copy()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>euler</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> allocated via <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#cogl-euler-copy" title="cogl_euler_copy ()"><code class="function">cogl_euler_copy()</code></a>
</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>